osg::BufferObject Class Reference

`#include <BufferObject>`

Inheritance diagram for osg::BufferObject:

## Public Member Functions

| BufferObject ()
| BufferObject (const BufferObject &bo, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
void | setTarget (GLenum target)
GLenum | getTarget () const
void | setUsage (GLenum usage)
GLenum | getUsage () const
BufferObjectProfile & | getProfile ()
const BufferObjectProfile & | getProfile () const
void | setCopyDataAndReleaseGLBufferObject (bool copyAndRelease)
bool | getCopyDataAndReleaseGLBufferObject () const
void | dirty ()
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
void | releaseGLObjects (State *state=0) const
unsigned int | addBufferData (BufferData *bd)
void | removeBufferData (unsigned int index)
void | removeBufferData (BufferData *bd)
void | setBufferData (unsigned int index, BufferData *bd)
BufferData * | getBufferData (unsigned int index)
const BufferData * | getBufferData (unsigned int index) const
unsigned int | getNumBufferData () const
void | setGLBufferObject (unsigned int contextID, GLBufferObject *glbo)
GLBufferObject * | getGLBufferObject (unsigned int contextID) const
GLBufferObject * | getOrCreateGLBufferObject (unsigned int contextID) const
unsigned int | computeRequiredBufferSize () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Static Public Member Functions

static void | deleteBufferObject (unsigned int contextID, GLuint globj)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Protected Types

typedef std::vector< BufferData * > | BufferDataList
typedef osg::buffered_object< osg::ref_ptr< GLBufferObject > > | GLBufferObjects

## Protected Member Functions

| ~BufferObject ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

BufferObjectProfile | _profile
bool | _copyDataAndReleaseGLBufferObject
BufferDataList | _bufferDataList
GLBufferObjects | _glBufferObjects
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Member Typedef Documentation

## BufferDataList

typedef std::vector< BufferData* > osg::BufferObject::BufferDataList

protected

## GLBufferObjects

typedef osg::buffered_object< osg::ref_ptr<GLBufferObject> > osg::BufferObject::GLBufferObjects

protected

## Constructor & Destructor Documentation

## BufferObject() [1/2]

osg::BufferObject::BufferObject | ( |  | ) |

Referenced by BufferObject(), and isSameKindAs().

## BufferObject() [2/2]

osg::BufferObject::BufferObject | ( | const BufferObject & | bo,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References BufferObject(), and osg::CopyOp::SHALLOW_COPY.

## ~BufferObject()

osg::BufferObject::~BufferObject | ( |  | ) |

protected

## Member Function Documentation

## addBufferData()

unsigned int osg::BufferObject::addBufferData | ( | BufferData * | bd | ) |

## className()

virtual const char * osg::BufferObject::className | ( |  | ) | const

inline virtual

return the name of the object's class type. Must be defined by derived classes.

Implements osg::Object.

## computeRequiredBufferSize()

unsigned int osg::BufferObject::computeRequiredBufferSize | ( |  | ) | const

## deleteBufferObject()

void osg::BufferObject::deleteBufferObject | ( | unsigned int | contextID,
|  | GLuint | globj )

static

deprecated, provided for backwards compatibility.

## dirty()

void osg::BufferObject::dirty | ( |  | ) |

Referenced by osg::PixelDataBufferObject::setDataSize().

## getBufferData() [1/2]

BufferData * osg::BufferObject::getBufferData | ( | unsigned int | index | ) |

inline

References _bufferDataList.

## getBufferData() [2/2]

const BufferData * osg::BufferObject::getBufferData | ( | unsigned int | index | ) | const

inline

References _bufferDataList.

## getCopyDataAndReleaseGLBufferObject()

bool osg::BufferObject::getCopyDataAndReleaseGLBufferObject | ( |  | ) | const

inline

Get whether the BufferObject should use a GLBufferObject just for copying the BufferData and release it immediately.

References _copyDataAndReleaseGLBufferObject.

## getGLBufferObject()

GLBufferObject * osg::BufferObject::getGLBufferObject | ( | unsigned int | contextID | ) | const

inline

References _glBufferObjects.

## getNumBufferData()

unsigned int osg::BufferObject::getNumBufferData | ( |  | ) | const

inline

References _bufferDataList.

## getOrCreateGLBufferObject()

GLBufferObject * osg::BufferObject::getOrCreateGLBufferObject | ( | unsigned int | contextID | ) | const

## getProfile() [1/2]

BufferObjectProfile & osg::BufferObject::getProfile | ( |  | ) |

inline

References _profile.

## getProfile() [2/2]

const BufferObjectProfile & osg::BufferObject::getProfile | ( |  | ) | const

inline

References _profile.

## getTarget()

GLenum osg::BufferObject::getTarget | ( |  | ) | const

inline

References _profile.

## getUsage()

GLenum osg::BufferObject::getUsage | ( |  | ) | const

inline

Get the type of usage the buffer object has been set up for.

References _profile.

## isSameKindAs()

virtual bool osg::BufferObject::isSameKindAs | ( | const Object * | obj | ) | const

inline virtual

Reimplemented from osg::Object.

References BufferObject(), NULL, and osg::Object::Object().

## libraryName()

virtual const char * osg::BufferObject::libraryName | ( |  | ) | const

inline virtual

return the name of the object's library. Must be defined by derived classes. The OpenSceneGraph convention is that the namespace of a library is the same as the library name.

Implements osg::Object.

## releaseGLObjects()

void osg::BufferObject::releaseGLObjects | ( | State * | state = 0 | ) | const

virtual

If State is non-zero, this function releases OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented from osg::Object.

## removeBufferData() [1/2]

void osg::BufferObject::removeBufferData | ( | BufferData * | bd | ) |

## removeBufferData() [2/2]

void osg::BufferObject::removeBufferData | ( | unsigned int | index | ) |

## resizeGLObjectBuffers()

virtual void osg::BufferObject::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::Object.

Reimplemented in osg::PixelDataBufferObject.

## setBufferData()

void osg::BufferObject::setBufferData | ( | unsigned int | index,
|  | BufferData * | bd )

## setCopyDataAndReleaseGLBufferObject()

void osg::BufferObject::setCopyDataAndReleaseGLBufferObject | ( | bool | copyAndRelease | ) |

inline

Set whether the BufferObject should use a GLBufferObject just for copying the BufferData and release it immediately so that it may be reused.

References _copyDataAndReleaseGLBufferObject.

## setGLBufferObject()

void osg::BufferObject::setGLBufferObject | ( | unsigned int | contextID,
|  | GLBufferObject * | glbo )

inline

References _glBufferObjects.

## setTarget()

void osg::BufferObject::setTarget | ( | GLenum | target | ) |

inline

References _profile.

## setUsage()

void osg::BufferObject::setUsage | ( | GLenum | usage | ) |

inline

Set what type of usage the buffer object will have. Options are: GL_STREAM_DRAW, GL_STREAM_READ, GL_STREAM_COPY, GL_STATIC_DRAW, GL_STATIC_READ, GL_STATIC_COPY, GL_DYNAMIC_DRAW, GL_DYNAMIC_READ, or GL_DYNAMIC_COPY.

References _profile.

## Member Data Documentation

## _bufferDataList

BufferDataList osg::BufferObject::_bufferDataList

protected

Referenced by getBufferData(), getBufferData(), and getNumBufferData().

## _copyDataAndReleaseGLBufferObject

bool osg::BufferObject::_copyDataAndReleaseGLBufferObject

protected

Referenced by getCopyDataAndReleaseGLBufferObject(), and setCopyDataAndReleaseGLBufferObject().

## _glBufferObjects

GLBufferObjects osg::BufferObject::_glBufferObjects

mutable protected

Referenced by getGLBufferObject(), osg::PixelBufferObject::isPBOSupported(), and setGLBufferObject().

## _profile

BufferObjectProfile osg::BufferObject::_profile

protected

Referenced by osg::PixelDataBufferObject::getDataSize(), getProfile(), getProfile(), getTarget(), getUsage(), osg::PixelDataBufferObject::setDataSize(), setTarget(), and setUsage().

The documentation for this class was generated from the following file:

- BufferObject